@echo off

cls
setlocal
title R4 Downloader
echo *************************
echo *     R4 Downloader     *
echo *   (c)2020 Yoshi128k   *
echo *************************
echo The user-friendly installer for your R4iSDHC/R4i-SDHC cart.
timeout /t 2 /nobreak >nul
pause

:mainmenu
cls
echo *Select an option*
echo.
echo 1. Download Stock Kernel (if you dare)
echo 2. Download RGFMCU (YSMenu)
echo 3. Offline Install
echo 4. Exit
set /p option="Type a number and press ENTER: "
if %option% EQU 1 goto stock
if %option% EQU 2 goto RGFMCU
if %option% EQU 3 goto offline
if %option% EQU 4 goto quit

:stock
cls
echo Select the URL that corresponds to the URL on the label of your card:
echo .
echo 1. R4i-SDHC.com
echo 2. R4iSDHC.com
echo.
set /p option="Type a number and press ENTER: "
if %option% EQU 1 goto stock_r4i_sdhc
if %option% EQU 2 goto stock_r4isdhc

:stock_r4i_sdhc
cls
echo Ready to download R4i-SDHC 3DS (RTS) kernel, version 1.85b
echo Oh, and by the way, the files will be downloaded to the folder where the downloader is.
pause
echo Starting BITS
powershell /c "BitsTransfer; Start-BitsTransfer 'https://gbatemp.net/download/firmware-v1-85b-for-r4-sdhc-upgrade-r4i-sdhc-upgrade-r4i-3ds-www-r4i-sdhc-com-english-clone-fix.37690/download' '%CD%\R4i-3DSV1.85bEnglish.zip'"
echo Complete!
pause
goto r4i_sdhc_install

:stock_r4isdhc
cls
echo Ready to download R4iSDHC 20XX kernel, version 4.0b
echo Oh, and by the way, the files will be downloaded to the folder where the downloader is.
pause
echo Starting BITS
powershell /c "BitsTransfer; Start-BitsTransfer 'hhttps://gbatemp.net/download/kernel-v4-0b-for-r4-sdhc-gold-pro-rts-lite-dual-core-snoopy-upgrade-r4isdhc-com.37072/download' '%CD%\R4i-V4.0bEnglish.zip'"
echo Complete!
pause
goto r4isdhc_install

:r4i_sdhc_install
cls
echo Enter the drive letter of the microSD card you would like to (re)install this kernel on.
echo Ensure that the card is formatted as FAT32.
set /p driveletter=""
echo Now extracting and copying the kernel files . . .
powershell /c "Expand-Archive -LiteralPath "%CD%\R4i-3DSV1.85bEnglish.zip" -DestinationPath %CD%\R4i-3DS V1.85b English"
xcopy "%CD%\R4i-3DS V1.85b English" %driveletter%:\ /E
echo Complete!
pause
goto complete

:r4isdhc_install
cls
echo Enter the drive letter of the microSD card you would like to (re)install this kernel on.
echo Ensure that the card is formatted as FAT32.
set /p driveletter=""
echo Now extracting and copying the kernel files . . .
powershell /c "Expand-Archive -LiteralPath "%CD%\R4i-V4.0bEnglish.zip" -DestinationPath %CD%"
xcopy "%CD%\R4i-V4.0b English" %driveletter%:\ /E
echo Complete!
pause
goto complete

:RGFMCU
cls
echo Ready to download the RetroGameFan Multi-Cart Update, version 7.06
pause
echo Starting cURL
curl https://gbatemp.net/download/retrogamefan-multi-cart-update.35737/download?version=35961 -o RGFMCU.7z
echo Complete!
pause
goto RGFMCU_install

:RGFMCU_install
cls
powershell write-host -fore Yellow ====IMPORTANT====
echo Before continuing, backup any data on your microSD card, and then format the card with Panasonic's SD Formatter,
echo making sure to select "Overwrite format."
echo.
pause
cls
echo Enter the drive letter of your microSD card.
set /p driveletter=""
cls
echo Now extracting and copying the kernel files . . .
%CD%\7ZA\7za.exe x %CD%\RGFMCU.7z "-o%CD%\RGFMCU" -aoa -r
xcopy "%CD%\RGFMCU\RetroGameFan Multi Cart Update v7.06\R4i-SDHC YSMenu" %driveletter%:\ /E
echo Complete!
pause
goto complete

:complete
cls
echo Congratulations!
echo.
echo You have successfully installed a kernel onto your R4 clone's microSD card.
echo Now you can enjoy games, media, and much more!
echo.
echo If you ever need any assistance, head on over to GBAtemp(That's where you got this program.)
echo.
echo -Yoshi128k :)
pause
goto mainmenu

:offline
cls
echo ==Offline Install==
echo.
echo If yu have already downloaded the kernel files, you can get directly into installing the kernel
echo.
echo Select a kernel:
echo.
echo 1. R4iSDHC Stock
echo 2. R4i-SDHC Stock
echo 3. RGFMCU (YSMenu)
set /p option=""
if %option% EQU 1 goto r4isdhc_install
if %option% EQU 2 goto r4i_sdhc_install
if %option% EQU 3 goto RGFMCU_install

:quit
endlocal
title Command Prompt
cls
cmd